@ECHO off
rem ******************************************************************************************************************************
rem * Licensed Materials - Property of IBM                                                                                       *
rem * (c) Copyright IBM Corp. 2008, 2009 All Rights Reserved.                                                                    *
rem *                                                                                                                            *
rem *US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp*
rem ******************************************************************************************************************************


IF NOT DEFINED LOCALE (SET LOCALE= )
SET LOCEN=0409
SET LOCIT=0410 
SET LOCJP=0411 
SET LOCKO=0412 
SET LOCPO=0415 
SET LOCCHS=0804
SET LOCCHT=0404


IF NOT DEFINED CURINST (SET CURINST= )
IF NOT DEFINED DBNAME (SET DBNAME= )
IF NOT DEFINED DBUSER (SET DBUSER= )
IF NOT DEFINED DBPASSWD (SET DBPASSWD= )
IF NOT DEFINED NF_SCHEMA (SET NF_SCHEMA= )
IF NOT DEFINED STAR_SCHEMA (SET STAR_SCHEMA= )
IF NOT DEFINED REP_USER (SET REP_USER= )
IF NOT DEFINED DATA_HOME (SET DATA_HOME= )
IF NOT DEFINED START_YEAR (SET START_YEAR= )
IF NOT DEFINED END_YEAR (SET END_YEAR= )

IF NOT DEFINED JAVA_HOME (SET JAVA_HOME= )



SET EXITCODE=0
SET MESSAGE= xxx


IF NOT EXIST set_env.bat (
                           SET EXITCODE=4597 
                           GOTO done
                                    ) ELSE (                
                       call set_env.bat
                                  )



IF "%JAVA_HOME%" EQU " " (
SET EXITCODE= 4596 
GOTO done)  


SET CURDIR=%CD%

CD /d "%JAVA_HOME%\bin"
IF "%ERRORLEVEL%" EQU "1" (
SET EXITCODE=4596
GOTO done)

IF NOT EXIST java.exe (
SET EXITCODE= 4598
GOTO done   ) 

CD /d %CURDIR%

set path=%JAVA_HOME%\bin;%path%

REG QUERY "HKCU\Control Panel\International" /v Locale>locale.txt

java com.ibm.rational.vega.dw.SearchAndReplace %LOCIT% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCIT%
SET SQLVARF=ascii\vars_it.sql
call lang\it\messages.bat) 
java com.ibm.rational.vega.dw.SearchAndReplace %LOCJP% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCJP%
SET SQLVARF=ascii\vars_jp.sql
call lang\jp\messages.bat)
java com.ibm.rational.vega.dw.SearchAndReplace %LOCKO% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCKO%
SET SQLVARF=ascii\vars_kr.sql
call lang\kr\messages.bat)
java com.ibm.rational.vega.dw.SearchAndReplace %LOCPO% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCPO%
SET SQLVARF=ascii\vars_pl.sql
call lang\pl\messages.bat)
java com.ibm.rational.vega.dw.SearchAndReplace %LOCCHS% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCCHS%
SET SQLVARF=ascii\vars_zh_CN.sql
call lang\zh_CN\messages.bat)
java com.ibm.rational.vega.dw.SearchAndReplace %LOCCHT% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCCHT%
SET SQLVARF=ascii\vars_zh_TW.sql
call lang\zh_TW\messages.bat)
java com.ibm.rational.vega.dw.SearchAndReplace %LOCEN% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCEN%
SET SQLVARF=ascii\vars_en.sql
call lang\en\messages.bat
)

IF "%LOCALE%" EQU " " (
SET LOCALE=%LOCEN%
SET SQLVARF=ascii\vars_en.sql
call lang\en\messages.bat)

IF "%1" EQU "-validate" (GOTO validate)
REM IF "%2" NEQ "" (IF "%2" EQU "-validate" (GOTO validate ))
REM IF "%3" NEQ "" (IF "%3" EQU "-validate" (GOTO validate ))



SET EXITCODE=0
SET MESSAGE=No errors




SET /A SILENT=0
IF "%1" EQU "-silent" (
SET /A SILENT=1) 

SET DB2_CMD=
IF "%1" EQU "-debug" (SET DB2_CMD= db2 -tvsf ) ELSE (SET DB2_CMD= db2 -tsf)
IF "%2" NEQ "" (IF "%2" EQU "-debug" (SET DB2_CMD= db2 -tvf ) ELSE (SET DB2_CMD= db2 -tf))



IF %SILENT% EQU 0 (
ECHO %CRREWECH001%)

IF %SILENT% EQU 0 (
SET /P CURINST=%CRREWPRMPT001% 
)
IF "%CURINST%" EQU " " (
SET EXITCODE=%CRREW4501E%
SET MESSAGE=%CRREWMSGE001%
GOTO done)  

IF %SILENT% EQU 0 (
SET /P DBNAME=%CRREWPRMPT002%
)
IF "%DBNAME%" EQU " " (
SET EXITCODE=%CRREW4502E%
SET MESSAGE=%CRREWMSGE002%
GOTO done) 

IF %SILENT% EQU 0 (
SET /P DBUSER=%CRREWPRMPT003%
)
IF "%DBUSER%" EQU " " (
SET EXITCODE=%CRREW4503E%
SET MESSAGE=%CRREWMSGE003%
GOTO done)

IF %SILENT% EQU 0 (
SET /P DBPASSWD=%CRREWPRMPT004%
)

IF "%DBPASSWD%" EQU " " (
SET EXITCODE=%CRREW4504E%
SET MESSAGE=%CRREWMSGE004%
GOTO done)

IF %SILENT% EQU 0 (
SET /P NF_SCHEMA=%CRREWPRMPT005%
)
IF "%NF_SCHEMA%" EQU " " (
SET EXITCODE=%CRREW4505E%
SET MESSAGE=%CRREWMSGE005%
GOTO done)

IF %SILENT% EQU 0 (
SET /P STAR_SCHEMA=%CRREWPRMPT006%
)
IF "%STAR_SCHEMA%" EQU " " (
SET EXITCODE=%CRREW4506E%
SET MESSAGE=%CRREWMSGE006%
GOTO done)

IF %SILENT% EQU 0 (
SET /P REP_USER=%CRREWPRMPT007%
)
IF "%REP_USER%" EQU " " (
SET EXITCODE=%CRREW4507E%
SET MESSAGE=%CRREWMSGE007%
GOTO done)

IF "%DBUSER%" EQU "%REP_USER%" (
SET EXITCODE=%CRREW4595E%
SET MESSAGE=%CRREWMSGE095%
GOTO done)


IF %SILENT% EQU 0 (
SET /P DATA_HOME=%CRREWPRMPT008%
)
IF "%DATA_HOME%" EQU " " (
SET EXITCODE=%CRREW4508E%
SET MESSAGE=%CRREWMSGE008%
GOTO done)

SET DATA_HOME=%DATA_HOME%\%DBNAME%

IF %SILENT% EQU 0 (
SET /P START_YEAR=%CRREWPRMPT009%
)
IF "%START_YEAR%" EQU " " (
SET EXITCODE=%CRREW4509E%
SET MESSAGE=%CRREWMSGE009%
GOTO done)

IF %SILENT% EQU 0 (
SET /P END_YEAR=%CRREWPRMPT010%
)
IF "%END_YEAR%" EQU " " (
SET EXITCODE=%CRREW4510E%
SET MESSAGE=%CRREWMSGE010%
GOTO done)


)

SET CONNSTR= db2 CONNECT TO %DBNAME% USER %DBUSER% USING "%DBPASSWD%"

SET DB2INSTANCE=%CURINST%

IF %SILENT% EQU 1 (
SETLOCAL ENABLEDELAYEDEXPANSION
%CONNSTR%
db2 "SELECT COUNT(*) FROM CONFIG.ETL_INFO"
IF "!ERRORLEVEL!" EQU "0" (
GOTO done)
)


IF NOT EXIST work_spc\nul (MKDIR work_spc) ELSE (
RMDIR /S /Q work_spc
MKDIR work_spc
)
IF "%ERRORLEVEL%" NEQ "0" (
SET EXITCODE=%CRREW4576E%
SET MESSAGE=%CRREWMSGE076%
GOTO done)
IF NOT EXIST logs\nul (MKDIR logs) ELSE (
RMDIR /S /Q logs
MKDIR logs
)
IF "%ERRORLEVEL%" NEQ "0" (
SET EXITCODE=%CRREW4576E%
SET MESSAGE=%CRREWMSGE076%
GOTO done)
IF NOT EXIST work_spc\temp\nul (MKDIR work_spc\temp) ELSE (
RMDIR /S /Q work_spc\temp
MKDIR work_spc\temp
)
IF "%ERRORLEVEL%" NEQ "0" (
SET EXITCODE=%CRREW4576E%
SET MESSAGE=%CRREWMSGE076%
GOTO done)

XCOPY /Y /I /E /Q createDB work_spc\createDB
IF %ERRORLEVEL% GTR 1 ( 
SET MESSAGE=%CRREWMSGE024%
SET EXITCODE=%CRREW4524E%
GOTO done)
XCOPY /Y /I /E /Q ddl work_spc\ddl
IF %ERRORLEVEL% GTR 1 ( 
SET MESSAGE=%CRREWMSGE024%
SET EXITCODE=%CRREW4524E%
GOTO done)
XCOPY /Y /I /E /Q scripts work_spc\scripts
IF %ERRORLEVEL% GTR 1 ( 
SET MESSAGE=%CRREWMSGE024%
SET EXITCODE=%CRREW4524E%
GOTO done)

java com.ibm.rational.vega.dw.SearchAndReplace $DBNAME %DBNAME% createDB\createdb.sql work_spc\createDB\createdb.sql
java com.ibm.rational.vega.dw.SearchAndReplace $BASEDIR "%DATA_HOME%"\ createDB\tbspace.sql work_spc\createDB\tbspace.sql
java com.ibm.rational.vega.dw.SearchAndReplace $NF_SCHEMA %NF_SCHEMA% ddl\createNF.ddl work_spc\ddl\createNF.ddl
java com.ibm.rational.vega.dw.SearchAndReplace $NF_SCHEMA %NF_SCHEMA% scripts\initNF.sql work_spc\scripts\initNF.sql
java com.ibm.rational.vega.dw.SearchAndReplace $STAR_SCHEMA %STAR_SCHEMA% ddl\createSTAR.ddl work_spc\ddl\createSTAR.ddl
java com.ibm.rational.vega.dw.SearchAndReplace $STAR_SCHEMA %STAR_SCHEMA% scripts\initSTAR.sql work_spc\scripts\initSTAR.sql
java com.ibm.rational.vega.dw.SearchAndReplace $STAR_SCHEMA %STAR_SCHEMA% scripts\dtPopulate.sql work_spc\scripts\dtPopulate.sql
java com.ibm.rational.vega.dw.SearchAndReplace $STAR_SCHEMA %STAR_SCHEMA% scripts\%SQLVARF% work_spc\scripts\%SQLVARF%

java com.ibm.rational.vega.dw.SearchAndReplace $STAR_SCHEMA %STAR_SCHEMA% scripts\star_grants.sql work_spc\temp\star_grants1.sql
java com.ibm.rational.vega.dw.SearchAndReplace $REP_USER %REP_USER% work_spc\temp\star_grants1.sql work_spc\scripts\star_grants.sql

java com.ibm.rational.vega.dw.SearchAndReplace $STAR_SCHEMA %STAR_SCHEMA% ddl\createSTARViews.ddl work_spc\temp\createSTARViews1.ddl
java com.ibm.rational.vega.dw.SearchAndReplace $NF_SCHEMA %NF_SCHEMA% work_spc\temp\createSTARViews1.ddl work_spc\ddl\createSTARViews.ddl

RMDIR /S /Q work_spc\temp

db2 terminate

%DB2_CMD% work_spc\createDB\createdb.sql> logs\createdb.log
java com.ibm.rational.vega.dw.SearchAndReplace SQL "%CD%"\logs\createdb.log>nul
IF "%ERRORLEVEL%" EQU "1" ( 
SET MESSAGE=%CRREWMSGE013%  
SET EXITCODE=%CRREW4513E%
ECHO %CRREWECH003%
GOTO done)

call work_spc\createDB\db2_set.bat
db2set>logs\db2_set.log
call work_spc\createDB\db_cfg.bat %DBNAME%>logs\db_cfg.log
call work_spc\createDB\dbm_cfg.bat>logs\dbm_cfg.log
%CONNSTR%

%DB2_CMD% work_spc\createDB\bufferpool.sql> logs\bufferpool.log
java com.ibm.rational.vega.dw.SearchAndReplace SQLSTATE "%CD%"\logs\bufferpool.log>nul
IF "%ERRORLEVEL%" EQU "1" ( 
SET MESSAGE=%CRREWMSGE014%  
SET EXITCODE=%CRREW4514E%
ECHO %CRREWECH004%
GOTO done)

db2 force applications all
db2stop force
db2start
db2start

%CONNSTR%

%DB2_CMD% work_spc\createDB\tbspace.sql> logs\tbspace.log
java com.ibm.rational.vega.dw.SearchAndReplace SQLSTATE "%CD%"\logs\tbspace.log>nul
IF "%ERRORLEVEL%" EQU "1" ( 
SET MESSAGE=%CRREWMSGE015%  
SET EXITCODE=%CRREW4515E%
ECHO %CRREWECH005%
GOTO done)

%DB2_CMD% work_spc\ddl\createSTGCFG.ddl> logs\createSTGCFG.log
java com.ibm.rational.vega.dw.SearchAndReplace SQLSTATE "%CD%"\logs\createSTGCFG.log>nul
IF "%ERRORLEVEL%" EQU "1" ( 
SET MESSAGE=%CRREWMSGE016%  
SET EXITCODE=%CRREW4516E%
ECHO %CRREWECH006%
GOTO done)

%DB2_CMD% work_spc\ddl\createNF.ddl> logs\createNF.log
java com.ibm.rational.vega.dw.SearchAndReplace SQLSTATE "%CD%"\logs\createNF.log>nul
IF "%ERRORLEVEL%" EQU "1" ( 
SET MESSAGE=%CRREWMSGE017%  
SET EXITCODE=%CRREW4517E%
ECHO %CRREWECH007%
GOTO done)

%DB2_CMD% work_spc\ddl\createSTAR.ddl> logs\createSTAR.log
java com.ibm.rational.vega.dw.SearchAndReplace SQLSTATE "%CD%"\logs\createSTAR.log>nul
IF "%ERRORLEVEL%" EQU "1" ( 
SET MESSAGE=%CRREWMSGE018%  
SET EXITCODE=%CRREW4518E%
ECHO %CRREWECH008%
GOTO done)

%DB2_CMD% work_spc\ddl\createSTARViews.ddl> logs\createSTARViews.log
java com.ibm.rational.vega.dw.SearchAndReplace SQLSTATE "%CD%"\logs\createSTARViews.log>nul
IF "%ERRORLEVEL%" EQU "1" ( 
SET MESSAGE=%CRREWMSGE019%  
SET EXITCODE=%CRREW4519E%
ECHO %CRREWECH009%
GOTO done)

%DB2_CMD% work_spc\scripts\initCONFIG.sql> logs\initCONFIG.log
java com.ibm.rational.vega.dw.SearchAndReplace SQLSTATE "%CD%"\logs\initCONFIG.log>nul
IF "%ERRORLEVEL%" EQU "1" ( 
SET MESSAGE=%CRREWMSGE020%  
SET EXITCODE=%CRREW4520E%
ECHO %CRREWECH010%
GOTO done)

%DB2_CMD% work_spc\scripts\initNF.sql> logs\initNF.log
java com.ibm.rational.vega.dw.SearchAndReplace SQLSTATE "%CD%"\logs\initNF.log>nul
IF "%ERRORLEVEL%" EQU "1" ( 
SET MESSAGE=%CRREWMSGE021%  
SET EXITCODE=%CRREW4521E%
ECHO %CRREWECH011%
GOTO done)

%DB2_CMD% work_spc\scripts\initSTAR.sql> logs\initSTAR.log
java com.ibm.rational.vega.dw.SearchAndReplace SQLSTATE "%CD%"\logs\initSTAR.log>nul
IF "%ERRORLEVEL%" EQU "1" ( 
SET MESSAGE=%CRREWMSGE022%  
SET EXITCODE=%CRREW4522E%
ECHO %CRREWECH012%
GOTO done)

%DB2_CMD% work_spc\scripts\star_grants.sql> logs\star_grants.log
java com.ibm.rational.vega.dw.SearchAndReplace SQLSTATE "%CD%"\logs\star_grants.log>nul
IF "%ERRORLEVEL%" EQU "1" ( 
SET MESSAGE=%CRREWMSGE023%  
SET EXITCODE=%CRREW4523E%
ECHO %CRREWECH013%
GOTO done)

%DB2_CMD% work_spc\scripts\%SQLVARF%>logs\dtPopulate.log

java com.ibm.rational.vega.dw.SearchAndReplace SQLSTATE "%CD%"\logs\dtPopulate.log>nul
IF "%ERRORLEVEL%" EQU "1" (
SET MESSAGE=%CRREWMSGE025%  
SET EXITCODE=%CRREW4525E%
GOTO done)

db2 -td@ -vf work_spc\scripts\dtPopulate.sql>> logs\dtPopulate.log

db2 SET CURRENT SCHEMA %STAR_SCHEMA%
db2 "CALL %STAR_SCHEMA%.POPULATE_D_DATE(%START_YEAR%, %END_YEAR%, '%STAR_SCHEMA%')" >logs\populate-D_DATE.log
IF "%ERRORLEVEL%" EQU "1" (
SET MESSAGE=%CRREWMSGE025%  
SET EXITCODE=%CRREW4525E% 
ECHO %CRREWECH014%
GOTO done)

java com.ibm.rational.vega.dw.SearchAndReplace SQLSTATE "%CD%"\logs\populate-D_DATE.log>nul
IF "%ERRORLEVEL%" EQU "1" (
SET MESSAGE=%CRREWMSGE025%  
SET EXITCODE=%CRREW4525E% 
ECHO %CRREWECH014%
GOTO done)

GOTO done


:validate

SET EXITCODE=0
SET MESSAGE=No errors

IF NOT DEFINED CURINST (
SET EXITCODE=%CRREW4501E%
SET MESSAGE=%CRREWMSGE001%
GOTO done)  

IF NOT DEFINED DBNAME (
SET EXITCODE=%CRREW4502E%
SET MESSAGE=%CRREWMSGE002%
GOTO done)

IF NOT DEFINED DBUSER (
SET EXITCODE=%CRREW4503E%
SET MESSAGE=%CRREWMSGE003%
GOTO done)

IF NOT DEFINED DBPASSWD (
SET EXITCODE=%CRREW4504E%
SET MESSAGE=%CRREWMSGE004%
GOTO done)

IF NOT DEFINED NF_SCHEMA (
SET EXITCODE=%CRREW4505E%
SET MESSAGE=%CRREWMSGE005%
GOTO done)

IF NOT DEFINED STAR_SCHEMA (
SET EXITCODE=%CRREW4506E%
SET MESSAGE=%CRREWMSGE006%
GOTO done)

IF NOT DEFINED REP_USER (
SET EXITCODE=%CRREW4507E%
SET MESSAGE=%CRREWMSGE007%
GOTO done)

IF NOT DEFINED DATA_HOME (
SET EXITCODE=%CRREW4508E%
SET MESSAGE=%CRREWMSGE008%
GOTO done)

IF NOT DEFINED START_YEAR  (
SET EXITCODE=%CRREW4509E%
SET MESSAGE=%CRREWMSGE009%
GOTO done)


IF NOT DEFINED END_YEAR (
SET EXITCODE=%CRREW4510E%
SET MESSAGE=%CRREWMSGE010%
GOTO done)



REG QUERY "HKCU\Control Panel\International" /v Locale>nul
IF "%ERRORLEVEL%" NEQ "0" (
SET EXITCODE=%CRREW4585E%
SET MESSAGE=%CRREWMSGE085%
GOTO done
)

IF "%CURINST%" EQU " " (
SET EXITCODE=%CRREW4501E%
SET MESSAGE=%CRREWMSGE001%
GOTO done)  

IF "%DBNAME%" EQU " " (
SET EXITCODE=%CRREW4502E%
SET MESSAGE=%CRREWMSGE002%
GOTO done)

IF "%DBUSER%" EQU " " (
SET EXITCODE=%CRREW4503E%
SET MESSAGE=%CRREWMSGE003%
GOTO done)

IF "%DBPASSWD%" EQU " " (
SET EXITCODE=%CRREW4504E%
SET MESSAGE=%CRREWMSGE004%
GOTO done)

IF "%NF_SCHEMA%" EQU " " (
SET EXITCODE=%CRREW4505E%
SET MESSAGE=%CRREWMSGE005%
GOTO done)

IF "%STAR_SCHEMA%" EQU " " (
SET EXITCODE=%CRREW4506E%
SET MESSAGE=%CRREWMSGE006%
GOTO done)

IF "%REP_USER%" EQU " " (
SET EXITCODE=%CRREW4507E%
SET MESSAGE=%CRREWMSGE007%
GOTO done)

IF "%DATA_HOME%" EQU " " (
SET EXITCODE=%CRREW4508E%
SET MESSAGE=%CRREWMSGE008%
GOTO done)


IF "%START_YEAR%" EQU " " (
SET EXITCODE=%CRREW4509E%
SET MESSAGE=%CRREWMSGE009%
GOTO done)


IF "%END_YEAR%" EQU " " (
SET EXITCODE=%CRREW4510E%
SET MESSAGE=%CRREWMSGE010%
GOTO done)



db2ilist >db2ilist.txt
java com.ibm.rational.vega.dw.SearchAndReplace %CURINST% db2ilist.txt
IF "%ERRORLEVEL%" EQU "0" (
DEL /Q db2ilist.txt
SET EXITCODE=%CRREW4501E%
SET MESSAGE=%CRREWMSGE001%
GOTO done)  

DEL /Q db2ilist.txt

db2 attach to  %CURINST% user %DBUSER% using  "%DBPASSWD%"
IF "%ERRORLEVEL%" NEQ "0" (
SET EXITCODE=%CRREW4584E%
SET MESSAGE=%CRREWMSGE084%
GOTO done)  




IF "%DBUSER%" EQU "%REP_USER%" (
SET EXITCODE=%CRREW4595E%
SET MESSAGE=%CRREWMSGE095%
GOTO done)

GOTO done


:done 
db2 connect reset 
db2 terminate
echo %MESSAGE%:%EXITCODE%
echo %CRREWECH002%
EXIT /B %EXITCODE%