#!/bin/ksh
# ******************************************************************************************************************************
# * Licensed Materials - Property of IBM                                                                                       *
# * (c) Copyright IBM Corp. 2008, 2009 All Rights Reserved.                                                                    *
# *                                                                                                                            *
# *US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp*
# ******************************************************************************************************************************

rcrdone(){
db2 connect reset
db2 terminate
echo $MESSAGE:$EXITCODE
echo $CRREWECH002$
exit $EXITCODE
}

validate() {

if [ -z $CURINST ] 
then
	EXITCODE=$CRREW4501E
	MESSAGE=$CRREWMSGE001
	rcrdone
fi  

if [ -z $DBNAME ] 
then
	EXITCODE=$CRREW4502E
	MESSAGE=$CRREWMSGE002
	rcrdone
fi

if [ -z $DBUSER ] 
then
	EXITCODE=$CRREW4503E
	MESSAGE=$CRREWMSGE003
	rcrdone
fi

if [ -z $DBPASSWD ] 
then
	EXITCODE=$CRREW4504E
	MESSAGE=$CRREWMSGE004
	rcrdone
fi

if [ -z $NF_SCHEMA ] 
then
	EXITCODE=$CRREW4505E
	MESSAGE=$CRREWMSGE005
	rcrdone
fi

if [ -z $STAR_SCHEMA ] 
then
	EXITCODE=$CRREW4506E
	MESSAGE=$CRREWMSGE006
	rcrdone
fi

if [ -z $REP_USER ] 
then
	EXITCODE=$CRREW4507E
	MESSAGE=$CRREWMSGE007
	rcrdone
fi

if [ $DBUSER == $REP_USER ]
then
	EXITCODE=$CRREW4595E
	MESSAGE=$CRREWMSGE095
	rcrdone
fi

if [ -z $DATA_HOME ] 
then
	EXITCODE=$CRREW4508E
	MESSAGE=$CRREWMSGE008
	rcrdone
fi

if [ -z $START_YEAR  ] 
then
	EXITCODE=$CRREW4509E
	MESSAGE=$CRREWMSGE009
	rcrdone
fi


if [ -z $END_YEAR ] 
then
	EXITCODE=$CRREW4510E
	MESSAGE=$CRREWMSGE010
	rcrdone
fi




if [ -z $LANG ]
then
	EXITCODE=$CRREW4585E
	MESSAGE=$CRREWMSGE085
	rcrdone
fi

db2ilist>db2ilist.txt
grep -e $CURINST db2ilist.txt>/dev/null
if [ $? -eq 1 ]
then
	rm -f db2ilist.txt
	EXITCODE=$CRREW4501E
	MESSAGE=$CRREWMSGE001
	rcrdone
fi  

rm -f db2ilist.txt

db2 attach to  $CURINST user $DBUSER using  "$DBPASSWD"
if [ $? -ne 0 ] 
then
	EXITCODE=$CRREW4584E
	MESSAGE=$CRREWMSGE084
	rcrdone
fi  






rcrdone
}

chmod -R +x lang

if [ `echo $LANG | sed 's/\([a-z]*\).*/\1/'` == "en" ]
then 
     LOCALE="en"
     SQLVARF="utf8/vars_en.sql"
	. lang/en/messages.sh
fi	

if [ `echo $LANG | sed 's/\([a-z]*\).*/\1/'` == "it" ]
then 
	LOCALE="it"
	SQLVARF="utf8/vars_it.sql"
	. lang/it/messages.sh
fi	

if [ `echo $LANG | sed 's/\([a-z]*\).*/\1/'` == "pl" ]
then 
	LOCALE="pl"
	SQLVARF="utf8/vars_pl.sql"
	. lang/pl/messages.sh
fi	

if [ `echo $LANG | sed 's/\([a-z]*\).*/\1/'` == "ko" ]
then 
	LOCALE="kr"
	SQLVARF="utf8/vars_kr.sql"
	. lang/kr/messages.sh
fi

if [ `echo $LANG | sed 's/\([a-z]*\).*/\1/'` == "ja" ]
then 
	LOCALE="ja"
	SQLVARF="utf8/vars_ja.sql"
	. lang/ja/messages.sh
fi

if [ `echo $LANG | sed 's/\([a-z]*_[A-Z][A-Z]\).*/\1/'` == "zh_CN" ]
then 
	LOCALE="zh_CN"
	SQLVARF="utf8/vars_zh_CN.sql"
	. lang/zh_CN/messages.sh
fi

if [ `echo $LANG | sed 's/\([a-z]*_[A-Z][A-Z]\).*/\1/'` == "zh_TW" ]
then 
	LOCALE="zh_TW"
	SQLVARF="utf8/vars_zh_TW.sql"
	. lang/zh_TW/messages.sh
fi

if [ -z $LOCALE ]
then
	 LOCALE="en"
	 SQLVARF="utf8/vars_en.sql"
	. lang/en/messages.sh
fi	


SILENT=0
MESSAGE="No errors"
EXITCODE=0

DB2_CMD="db2 -tsf"

if [ $# -eq 1 ]
	then 
	if [ $1 == "-silent" ]
	then
			SILENT=1
	else 
			SILENT=0
	fi
	if [ $1 == "-debug" ]
	then
		DB2_CMD="db2 -tvsf"
		else 
			DB2_CMD="db2 -tsf"
	fi
fi

if [ $# -eq 1 ]
	then
	if [ $1 == "-validate" ]
		then
		   validate
	fi
fi	
	
if [ $# -eq 2 ]
then
	if [ $2 -eq "-debug" ]
	 then
			DB2_CMD="db2 -tvsf"
	else 
			DB2_CMD="db2 -tsf"
	fi
fi



if [ $SILENT -eq 0 ]
then 
	echo $CRREWECH001
fi	

if [ $SILENT -eq 0 ]
then 
	echo $CRREWPRMPT002
	read DBNAME
fi

if [ -z $DBNAME ]
then
	MESSAGE=$CRREWMSGE002
	EXITCODE=$CRREW4502E
	rcrdone
fi

if [ $SILENT -eq 0 ]
then 
	echo $CRREWPRMPT003
	read DBUSER
fi

if [ -z $DBUSER ]
then
	MESSAGE=$CRREWMSGE003
	EXITCODE=$CRREW4503E
	rcrdone
fi

if [ $SILENT -eq 0 ]
then 
	echo $CRREWPRMPT004
	read DBPASSWD
fi

if [ -z $DBPASSWD ]
then
	MESSAGE=$CRREWMSGE004
	EXITCODE=$CRREW4504E
	rcrdone
fi

if [ $SILENT -eq 0 ]
then 
	echo $CRREWPRMPT005
	read NF_SCHEMA
fi

if [ -z $NF_SCHEMA ]
then
	MESSAGE=$CRREWMSGE005
	EXITCODE=$CRREW4505E
	rcrdone
fi

if [ $SILENT -eq 0 ]
then 
	echo $CRREWPRMPT006
	read STAR_SCHEMA
fi

if [ -z $STAR_SCHEMA ]
then
	MESSAGE=$CRREWMSGE006
	EXITCODE=$CRREW4506E
	rcrdone
fi

if [ $SILENT -eq 0 ]
then 
	echo $CRREWPRMPT007
	read REP_USER
fi

if [ -z $REP_USER ]
then
	MESSAGE=$CRREWMSGE007
	EXITCODE=$CRREW4507E
	rcrdone
fi

if [ $DBUSER == $REP_USER ]
then
	EXITCODE=$CRREW4595E
	MESSAGE=$CRREWMSGE095
	rcrdone
fi

if [ $SILENT -eq 0 ]
then 
	echo $CRREWPRMPT008
	read DATA_HOME
fi

if [ -z $DATA_HOME ]
then
	MESSAGE=$CRREWMSGE008
	EXITCODE=$CRREW4508E
	rcrdone
fi


DATA_HOME=$DATA_HOME/$DBNAME

if [ $SILENT -eq 0 ]
then 
	echo $CRREWPRMPT009
	read START_YEAR
fi

if [ -z $START_YEAR ]
then
	MESSAGE=$CRREWMSGE009
	EXITCODE=$CRREW4509E
	rcrdone
fi

if [ $SILENT -eq 0 ]
then 
	echo $CRREWPRMPT010
	read END_YEAR
fi

if [ -z $END_YEAR ]
then
	MESSAGE=$CRREWMSGE010
	EXITCODE=$CRREW4510E
	rcrdone
fi






CONNSTR="db2 CONNECT TO $DBNAME USER $DBUSER USING $DBPASSWD"

if [ $SILENT -eq 1 ]
then 
	$CONNSTR
	db2 "SELECT COUNT(*) FROM CONFIG.ETL_INFO"
	if [ $? -eq 0 ]
	then
		rcrdone
	fi
fi	


CD=`pwd`

if [ ! -d $CD/work_spc ]
then
	mkdir $CD/work_spc
else
	rm -dfr $CD/work_spc
	mkdir $CD/work_spc
fi	
if [ $? -ne 0 ]
then
	MESSAGE=$CRREWMSGE076
	EXITCODE=$CRREW4576E
	rcrdone
fi
    

if [ ! -d $CD/logs ]
then
	mkdir $CD/logs
else
	rm -dfr $CD/logs
	mkdir $CD/logs	
fi
if [ $? -ne 0 ]
then
	MESSAGE=$CRREWMSGE076
	EXITCODE=$CRREW4576E
	rcrdone
fi
echo $DATA_HOME/|sed 's/\//\\\//g'>tmp1.txt


cp -r ./createDB $CD/work_spc
if [ $? -ne 0 ]
then
	MESSAGE=$CRREWMSGE024
	EXITCODE=$CRREW4524E
	rcrdone
fi

cp -r ./ddl $CD/work_spc
if [ $? -ne 0 ]
then
	MESSAGE=$CRREWMSGE024
	EXITCODE=$CRREW4524E
	rcrdone
fi
cp -r ./scripts $CD/work_spc
if [ $? -ne 0 ]
then
	MESSAGE=$CRREWMSGE024
	EXITCODE=$CRREW4524E
	rcrdone
fi

cat ./createDB/createdb.sql|sed -e "s/\$DBNAME/`echo $DBNAME`/g" > $CD/work_spc/createDB/createdb.sql
cat ./createDB/tbspace.sql|sed -e "s/\$BASEDIR/`cat tmp1.txt`/g" > $CD/work_spc/createDB/tbspace.sql
rm -f tmp1.txt
cat ./ddl/createNF.ddl|sed -e "s/\$NF_SCHEMA/`echo $NF_SCHEMA`/g" > $CD/work_spc/ddl/createNF.ddl
cat ./scripts/initNF.sql|sed -e "s/\$NF_SCHEMA/`echo $NF_SCHEMA`/g" > $CD/work_spc/scripts/initNF.sql
cat ./ddl/createSTAR.ddl|sed -e "s/\$STAR_SCHEMA/`echo $STAR_SCHEMA`/g" > $CD/work_spc/ddl/createSTAR.ddl
cat ./ddl/createSTARViews.ddl|sed -e "s/\$NF_SCHEMA/`echo $NF_SCHEMA`/g" |sed -e "s/\$STAR_SCHEMA/`echo $STAR_SCHEMA`/g"> $CD/work_spc/ddl/createSTARViews.ddl
cat ./scripts/initSTAR.sql|sed -e "s/\$STAR_SCHEMA/`echo $STAR_SCHEMA`/g" > $CD/work_spc/scripts/initSTAR.sql
cat ./scripts/star_grants.sql|sed -e "s/\$STAR_SCHEMA/`echo $STAR_SCHEMA`/g"|sed -e "s/\$REP_USER/`echo $REP_USER`/g"> $CD/work_spc/scripts/star_grants.sql
cat ./scripts/dtPopulate.sql|sed -e "s/\$STAR_SCHEMA/`echo $STAR_SCHEMA`/g" > $CD/work_spc/scripts/dtPopulate.sql
cat ./scripts/$SQLVARF|sed -e "s/\$STAR_SCHEMA/`echo $STAR_SCHEMA`/g" > $CD/work_spc/scripts/$SQLVARF

$DB2_CMD $CD/work_spc/createDB/createdb.sql >$CD/logs/createdb.log
grep -e "SQLSTATE" $CD/logs/createdb.log >/dev/null

if [ $? -eq 0 ]
then
	MESSAGE=$CRREWMSGE013  
	EXITCODE=$CRREW4513E
	echo $CRREWECH003
	rcrdone
fi
chmod +x ./work_spc/createDB/db2_set.sh
./work_spc/createDB/db2_set.sh
db2set>./logs/db2_set.log
chmod +x ./work_spc/createDB/db_cfg.sh
./work_spc/createDB/db_cfg.sh $DBNAME>./logs/db_cfg.log
chmod +x ./work_spc/createDB/dbm_cfg.sh
./work_spc/createDB/dbm_cfg.sh>./logs/dbm_cfg.log

$CONNSTR

$DB2_CMD ./work_spc/createDB/bufferpool.sql> ./logs/bufferpool.log
grep -e "SQLSTATE" $CD/logs/bufferpool.log>/dev/null
#if [ $? -eq 0 ]
#then
#	MESSAGE=$CRREWMSGE014 
#	EXITCODE=$CRREW4514E
#	echo $CRREWECH004
#	rcrdone
#fi

db2 force applications all
db2stop force
db2start


$CONNSTR

$DB2_CMD ./work_spc/createDB/tbspace.sql> ./logs/tbspace.log
grep -e " SQLSTATE" $CD/logs/tbspace.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRREWMSGE015
	EXITCODE=$CRREW4515E
	echo $CRREWECH005
	rcrdone
fi

$DB2_CMD ./work_spc/ddl/createSTGCFG.ddl> ./logs/createSTGCFG.log
grep -e " SQLSTATE" $CD/logs/createSTGCFG.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRREWMSGE016
	EXITCODE=$CRREW4516E
	echo $CRREWECH006
	rcrdone
fi

$DB2_CMD ./work_spc/ddl/createNF.ddl> ./logs/createNF.log
grep -e " SQLSTATE" $CD/logs/createNF.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRREWMSGE017
	EXITCODE=$CRREW4517E
	echo $CRREWECH007
	rcrdone
fi

$DB2_CMD ./work_spc/ddl/createSTAR.ddl> ./logs/createSTAR.log
grep -e " SQLSTATE" $CD/logs/createSTAR.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRREWMSGE018
	EXITCODE=$CRREW4518E
	echo $CRREWECH008
	rcrdone
fi

$DB2_CMD ./work_spc/ddl/createSTARViews.ddl> ./logs/createSTARViews.log
grep -e " SQLSTATE" $CD/logs/createSTARViews.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRREWMSGE019
	EXITCODE=$CRREW4519E
	echo $CRREWECH009
	rcrdone
fi

$DB2_CMD ./work_spc/scripts/initCONFIG.sql> ./logs/initCONFIG.log
grep -e " SQLSTATE" $CD/logs/initCONFIG.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRREWMSGE020
	EXITCODE=$CRREW4520E
	echo $CRREWECH010
	rcrdone
fi

$DB2_CMD ./work_spc/scripts/initNF.sql> ./logs/initNF.log
grep -e " SQLSTATE" $CD/logs/initNF.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRREWMSGE021
	EXITCODE=$CRREW4521E
	echo $CRREWECH011
	rcrdone
fi

$DB2_CMD ./work_spc/scripts/initSTAR.sql> ./logs/initSTAR.log
grep -e " SQLSTATE" $CD/logs/initSTAR.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRREWMSGE022
	EXITCODE=$CRREW4522E
	echo $CRREWECH012
	rcrdone
fi

$DB2_CMD ./work_spc/scripts/star_grants.sql> ./logs/star_grants.log
grep -e " SQLSTATE" $CD/logs/star_grants.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRREWMSGE023
	EXITCODE=$CRREW4523E
	echo $CRREWECH013
	rcrdone
fi

$DB2_CMD ./work_spc/scripts/$SQLVARF>./logs/dtPopulate.log
grep -e " SQLSTATE" $CD/logs/dtPopulate.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRREWMSGE025 
	EXITCODE=$CRREW4525E 
	rcrdone
fi
db2 -td@ -vf ./work_spc/scripts/dtPopulate.sql>> ./logs/dtPopulate.log

db2 SET CURRENT SCHEMA $STAR_SCHEMA
db2 "CALL $STAR_SCHEMA.POPULATE_D_DATE($START_YEAR, $END_YEAR, '$STAR_SCHEMA')" >./logs/populate-D_DATE.log
if [ $? -ne 0 ]
then
	MESSAGE=$CRREWMSGE025 
	EXITCODE=$CRREW4525E 
	echo $CRREWECH014
	rcrdone
fi

grep -e " SQLSTATE" $CD/logs/populate-D_DATE.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRREWMSGE025 
	EXITCODE=$CRREW4525E 
	echo $CRREWECH014
	rcrdone
fi

rcrdone


