--******************************************************************************************************************************
--* Licensed Materials - Property of IBM                                                                                       *
--* (c) Copyright IBM Corp. 2008, 2009 All Rights Reserved.                                                                    *
--*                                                                                                                            *
--*US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp*
--******************************************************************************************************************************

SET CURRENT SCHEMA $STAR_SCHEMA;

CREATE TABLE CAL_MESSAGES (
	CAL_ERROR_NO INTEGER,
	CAL_MESSAGE_CODE CHAR(12),
	CAL_ERR_MESSAGE VARCHAR (255)
)IN VSTR_32K INDEX IN VSTR_IDX;

INSERT INTO CAL_MESSAGES (CAL_ERROR_NO,CAL_MESSAGE_CODE,CAL_ERR_MESSAGE) VALUES (4586,'CRREW4586E','CRREW4586E: Error invalid calendar type. Specify 1 (gregorian), 2 (ISO)');
INSERT INTO CAL_MESSAGES (CAL_ERROR_NO,CAL_MESSAGE_CODE,CAL_ERR_MESSAGE) VALUES (4587,'CRREW4587E','CRREW4587E: Error START_YEAR is null OR greater than END_YEAR');
INSERT INTO CAL_MESSAGES (CAL_ERROR_NO,CAL_MESSAGE_CODE,CAL_ERR_MESSAGE) VALUES (4588,'CRREW4588E','CRREW4588E: Error END_YEAR is null OR less than START_YEAR');
INSERT INTO CAL_MESSAGES (CAL_ERROR_NO,CAL_MESSAGE_CODE,CAL_ERR_MESSAGE) VALUES (4589,'CRREW4589E','CRREW4589E: Error Warehouse schema not specified.  Specify a valid schema');
INSERT INTO CAL_MESSAGES (CAL_ERROR_NO,CAL_MESSAGE_CODE,CAL_ERR_MESSAGE) VALUES (4590,'CRREW4590E','CRREW4590E: Error Date Dimension is corrupted, smallest date does not equal January 1rst');
INSERT INTO CAL_MESSAGES (CAL_ERROR_NO,CAL_MESSAGE_CODE,CAL_ERR_MESSAGE) VALUES (4591,'CRREW4591E','CRREW4591E: Error Date Dimension is corrupted, largest date does not equal December 31rst');
INSERT INTO CAL_MESSAGES (CAL_ERROR_NO,CAL_MESSAGE_CODE,CAL_ERR_MESSAGE) VALUES (4592,'CRREW4592E','CRREW4592E: Error Date Dimension unsupported calendar');
INSERT INTO CAL_MESSAGES (CAL_ERROR_NO,CAL_MESSAGE_CODE,CAL_ERR_MESSAGE) VALUES (4593,'CRREW4593E','CRREW4593E: Error Date Dimension argument END_YEAR < MIN(YEAR) IN D_DATE');
INSERT INTO CAL_MESSAGES (CAL_ERROR_NO,CAL_MESSAGE_CODE,CAL_ERR_MESSAGE) VALUES (4594,'CRREW4594E','CRREW4594E: Error Date Dimension argument START_YEAR > MAX(YEAR) IN D_DATE');
INSERT INTO CAL_MESSAGES (CAL_ERROR_NO,CAL_MESSAGE_CODE,CAL_ERR_MESSAGE) VALUES (4505,'CRREW4505E','CRREW4505E: Error NF_SCHEMA schema can not be null');
INSERT INTO CAL_MESSAGES (CAL_ERROR_NO,CAL_MESSAGE_CODE,CAL_ERR_MESSAGE) VALUES (4506,'CRREW4506E','CRREW4506E: Error STAR_SCHEMA schema can not be null');
INSERT INTO CAL_MESSAGES (CAL_ERROR_NO,CAL_MESSAGE_CODE,CAL_ERR_MESSAGE) VALUES (4507,'CRREW4507E','CRREW4507E: Error REP_USER user name can not be null');
INSERT INTO CAL_MESSAGES (CAL_ERROR_NO,CAL_MESSAGE_CODE,CAL_ERR_MESSAGE) VALUES (4598,'CRREW4598E','CRREW4598E: Error cannot determine Insight version');
INSERT INTO CAL_MESSAGES (CAL_ERROR_NO,CAL_MESSAGE_CODE,CAL_ERR_MESSAGE) VALUES (4599,'CRREW4599E','CRREW4599E: Error cannot determine target Insight version');
INSERT INTO CAL_MESSAGES (CAL_ERROR_NO,CAL_MESSAGE_CODE,CAL_ERR_MESSAGE) VALUES (4600,'CRREW4600E','CRREW4600E: Error current version is greater than target version');
INSERT INTO CAL_MESSAGES (CAL_ERROR_NO,CAL_MESSAGE_CODE,CAL_ERR_MESSAGE) VALUES (4601,'CRREW4601E','CRREW4601E: Error executing the statement');
INSERT INTO CAL_MESSAGES (CAL_ERROR_NO,CAL_MESSAGE_CODE,CAL_ERR_MESSAGE) VALUES (4602,'CRREW4602E','CRREW4602E: Error there are dependent statements that have failled');


COMMIT;